<style>       
<!--
    A:link {text-decoration: none;}
    A:visited {text-decoration: none;}
    A:active {text-decoration: none;}
    A:hover {text-decoration: none;}
-->
</style>

<?php

//------------------------------------------------------------------------------------------
// 
// ---------------------------------------------------
// copyright 2000 by voxeo corporation. (see LGPL.txt)
// ---------------------------------------------------
//
// v1.0 Coded in PHP 4.0
// v1.0 Coded by Stephen J. Lewis
// This file is the main web-based script for editing the AutoAttendant 
// database file.  It is associated with the following files:
//		AutoAttendantAdmin.php  <---- PHP file that edits the information
//									  and transfers it to this file to be saved.
//		AutoAttendantDB         <---- Database file
//		AutoAttendant.php		<---- generates CallXML from the database
//		CallDestination.xml		|
//								|---- handles the calling and conferencing
//		DoTheCall.xml			|
//
//      passwords.inc           <---- Abstracted functions for HTTP and FTP
//                                    passwords.
//      Database-Linux.inc      <---- This contains all the abstracted database
//                                    routines for linux.
//      Database-Win32.inc      <---- This contains all the abstracted database
//                                    routines for Win32.
//
// The database is either an Interbase resource or MS Access file
// and contains one table, named AutoAttendantDB, with columns called:
//  	'Digit,'      'AudioURL,'     'Destination,' 'MenuName,' 
// 		'ActionType,' 'MenuPosition,' and 'UniqueID.'
//-------------------------------------------------------------------------------------------

//-----------------------------------------------------
// This little tweak is in case we are running under an
// Operating System that use case-sensitive URLs.
//-----------------------------------------------------

if ($HTTP_GET_VARS["os"] != "") { $HTTP_GET_VARS["OS"] = $HTTP_GET_VARS["os"]; }

$HTTP_GET_VARS["OS"] = strtolower($HTTP_GET_VARS["OS"]);

if ($HTTP_GET_VARS["OS"] == "linux") { include('database-linux.inc'); }
else 						         { include('database-win32.inc'); }

include('passwords.inc');

//------------------------------------------------------
// Make sure we are pointing to the right database file,
// depending on the operating system.  These can be 
// changed depending on the developer's setup and paths.
//------------------------------------------------------

if ($HTTP_GET_VARS["OS"] == "linux") { 
  $DatabaseName = "/www/html/aa/aa.gdb";
  $Path         = "http://linux1.voxeo.com/aa/";
}  // if statement
else { 
  $DatabaseName = "AutoAttendantDB";
  $Path         = "http://appserverdev.voxeo.com/autoattendant/";
}  // else statement



//-------------------------------------------------------------------------------------
// Simply function that redirects to a new page
//---------------------------------------------

function RedirectToNewURL( $Delay, $URLPlusQueryString ) {
  echo "<META HTTP-EQUIV = \"refresh\" CONTENT=\"$Delay; " . 
       "URL=$URLPlusQueryString\">";
  return("Nothing");       
}  // function statement

//-------------------------------------------------------------------------------------------

echo "<html><BODY BGColor=#264c73 TEXT=White LINK=White " .
	 "ALINK=#9999FF vlink=White leftmargin=0 topmargin=0>\n";
 
echo "<table width=850 cellspacing=0 cellpadding=0>";
echo "<tr><td align=left valign=top>";
echo "<img src=\"background_curve.gif\" width=\"28\" height=\"33\" alt=\"\" border=\"0\">";
echo "</td><td valign=middle>";
echo "<A HREF=\"http://www.voxeo.com\" TARGET=\"_blank\"><img src=\"logo.gif\" " .
     "width=244 height=70 alt=\"voxeo\" border=0></A>";
echo "</td><td valign=middle align=right>";
echo "<img src=\"top_slogan.gif\" width=523 height=58 border=0>";
echo "</td></tr></table><p>";

echo "<font color=White size=4 face=Helvetica>";  

//---------------------			
// Open up the database
//---------------------			
	 
$TempConnection = OpenDatabase($DatabaseName); 

$ValidDigits = Array("1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "*", "#", "A", "B", "C", "D");

//---------------------------------------------------------------------------
// Test to see if we are just adding a new entry and immediately hopping back
//---------------------------------------------------------------------------

if ( $HTTP_GET_VARS["AddEntry"] == "TRUE" ) {
  $TempMenuName = $HTTP_GET_VARS["MenuName"];
  
  if ($HTTP_GET_VARS["OS"] == "linux") {
    $TempSQL      = "select UNIQUEID from AUTOATTENDANTDB";
    $TempDatabase = ReadDatabase($TempConnection, $TempSQL);
    $NewUniqueID  = 0;
  
    //-------------------------------------------------------
    // Get the current max Unique ID and add 1 to that number
    //-------------------------------------------------------
  
    while ($TempRow = FetchRowFromDatabase($TempDatabase) ) {
      $TempID = GetResultFromRow( "UNIQUEID", $TempRow, $TempDatabase );
	
      if ($TempID > $NewUniqueID) { $NewUniqueID = $TempID; }
    }  // while statement
  
    $NewUniqueID++;
  
    if ($NewUniqueID < 1) { $NewUniqueID = 1; }
	
    $TempSQL = "insert into AUTOATTENDANTDB (DIGIT, AUDIOURL, DESTINATION, MENUNAME, ACTIONTYPE, " . 
			   "MENUPOSITION, UNIQUEID) values('', '', '', '$TempMenuName', 'Call', 99, $NewUniqueID)";	
  }  // if statement
  else { 
    $TempSQL = "insert into AUTOATTENDANTDB (DIGIT, AUDIOURL, DESTINATION, MENUNAME, ACTIONTYPE, " . 
			   "MENUPOSITION) values('', '', '', '$TempMenuName', 'Call', 99)";
  }  // else statement
  
  //---------------------
  // Do the insert entry
  //---------------------
  
  $TempDataBase = ReadDatabase( $TempConnection, $TempSQL ); 
			 
  $LengthOfDelay = 0;
}  // if statement

//--------------------------------------------------------------
// If we are adding a new menu, we need to do something specific
//--------------------------------------------------------------

elseif ($HTTP_GET_VARS["AddMenu"] == "TRUE") {
  echo "<form action=\"autoattendantworkhorse.php?OS=" . $HTTP_GET_VARS["OS"] . 
  	   "&AddMenu=SecondPass\" method=\"post\" name=\"AdminForm\">\n";
  echo "<table width=850 align=center bgcolor=#264c73><tr><td align=center>\n";
  echo "<br><font color=White size=4 face=Helvetica>Please enter the New Menu's Name: \n";
  
  echo "<input type=\"text\" name=\"NewMenuName\" value=\"\" size=\"20\" maxlength=\"30\">"; 
  echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type=\"Submit\" name=\"Submit\" value=\"Make the Menu\">";
  echo "</form>";
  echo "</td></tr></table>\n";
  
  $AutomaticReturn = "FALSE";
}  // elseif statement

//----------------------------------------------------------
// If we are running through the second pass of this, then
// we need to actually fill in the database with blank info.
//----------------------------------------------------------

elseif ($HTTP_GET_VARS["AddMenu"] == "SecondPass") {
			
  $TempMenuName  = $HTTP_POST_VARS["NewMenuName"];
  $LengthOfDelay = 7;  
  $InvalidChars  = "!@#$%^&*=\<>()[]{}-+_/?,.\"'";  
  
  //---------------------------------------------------------------------------
  // The name "Entire Database" is reserved, and cannot be used for a menu name
  //---------------------------------------------------------------------------
  
  if ( ($TempMenuName != "Entire Database") && 
       ($TempMenuName != "")                &&
	   (! similar_text( $TempMenuName, $InvalidChars) ) ) { 
  
    //-------------------------------
    // Query database for information
    //-------------------------------
  
    $TempSQL = "select MENUNAME from AUTOATTENDANTDB";
  
    $TempDataBase = ReadDatabase( $TempConnection, $TempSQL ); 
  
    $MenuExists = "FALSE";
  
    //----------------------------------------------------------------------------
    // We need to check to make sure our new menu does not match an existing menu.
    //----------------------------------------------------------------------------
  
    while( $TempRow = FetchRowFromDatabase( $TempDataBase ) ) { 
      $ZMenuName = GetResultFromRow( "MENUNAME", $TempRow, $TempDatabase );
	  
	  //---------------------------------
	  // Check to see if we have a match.
	  //---------------------------------
	  
	  if ($ZMenuName == $TempMenuName) {
	    $MenuExists = "TRUE";
	  }  // if statement
	
    }  // while statement  
 
    
	if ($MenuExists != "TRUE") {
	  //--------------------------------------------------------------
      // We only fill the first 12 slots up because the A, B, C, and D 
      // keys will probably never be used by 99% of all users.
      //--------------------------------------------------------------
      
	  
      if ($HTTP_GET_VARS["OS"] == "linux") {
        $TempSQL      = "select UNIQUEID from AUTOATTENDANTDB";
    	$TempDatabase = ReadDatabase($TempConnection, $TempSQL);
    	$NewUniqueID  = 0;
  
    	//-------------------------------------------------------
    	// Get the current max Unique ID and add 1 to that number
    	//-------------------------------------------------------
  
    	while ($TempRow = FetchRowFromDatabase($TempDatabase) ) {
      	  $TempID = GetResultFromRow( "UNIQUEID", $TempRow, $TempDatabase );
	
      	  if ($TempID > $NewUniqueID) { $NewUniqueID = $TempID; }
    	}  // while statement
  
    	$NewUniqueID++;
  
    	if ($NewUniqueID < 1) { $NewUniqueID = 1; }
      }  // if statement
      
	  for ($Loopy = 0; $Loopy < 4; $Loopy++) {
	    if ($HTTP_GET_VARS["OS"] == "linux") {
          $TempSQL = "insert into AUTOATTENDANTDB (DIGIT, AUDIOURL, DESTINATION, MENUNAME, " . 
		   	         "ACTIONTYPE, MENUPOSITION, UNIQUEID) values('$ValidDigits[$Loopy]', '', " .
				     "'', '$TempMenuName', 'Call', " . ($Loopy + 1) . ", ($NewUniqueID + $Loopy))";
		}  // if statement
		else {
          $TempSQL = "insert into AUTOATTENDANTDB (DIGIT, AUDIOURL, DESTINATION, MENUNAME, " . 
		   	         "ACTIONTYPE, MENUPOSITION) values('$ValidDigits[$Loopy]', '', " .
				     "'', '$TempMenuName', 'Call', " . ($Loopy + 1) . ")";
		}  // else statement
  
        //---------------------
        // Do the insert entry
        //---------------------
  
        $TempDataBase = ReadDatabase( $TempConnection, $TempSQL ); 
      }  // for statement
      
	  echo "<br><blockquote>Menu \"$TempMenuName\" has been successfully added.<br><br>" .
           "This page will automatically return to the Auto Attendant Administrative page in $LengthOfDelay seconds...\n" .
  	       "</blockquote>";		  
	}  // if statement
	else {
	  echo "<br><blockquote>Menu \"$TempMenuName\" already exists.<br>" .
	       "Your menu has <B>NOT</B> been added.<br><br>" .
           "This page will automatically return to the Auto Attendant Administrative page in $LengthOfDelay seconds...\n" .
  	       "</blockquote>";	  
	}  // else statement
  }  // if statement
  elseif ($TempMenuName == "Entire Database") {
    echo "<br><blockquote>The name \"$TempMenuName\" is reserved by Auto Attendant, and cannot be used.<br>" .
	     "Your menu has <B>NOT</B> been added.<br><br>" .
         "This page will automatically return to the Auto Attendant Administrative page in $LengthOfDelay seconds...\n" .
	     "</blockquote>";	 
	$TempMenuName = "";
  } // elseif statement
  else {
    echo "<br><blockquote>You have entered an invalid value for a Menu Name.<br>" .
	     "Your menu has <B>NOT</B> been added.<br><br>" .
         "This page will automatically return to the Auto Attendant Administrative page in $LengthOfDelay seconds...\n" .
	     "</blockquote>";	
	$TempMenuName = "Entire Database";
  }  // else statement
}  // elseif statement

//------------------------------------------------------
// Just in case a menuname is not passed for some reason
//------------------------------------------------------

elseif ($HTTP_GET_VARS["MenuName"] == "") {
  $LengthOfDelay=0;
}  // elseif

else {

$AudioURLIsBlank     = "NO";
$MenuNameIsBlank     = "NO";
$PositionIsBlank     = "NO";
$DigitIsBlank        = "NO";
$DestinationIsBlank  = "NO";
$DigitNotValid       = "NO";
$DuplicateDigit      = "NO";
$DuplicatePosition   = "NO";
$PositionNotValid    = "NO";
$DestinationNotValid = "NO";
$TempMenuName        = $HTTP_GET_VARS["MenuName"];
$EntireMenuDeleted   = "YES";

//---------------------------------------
// Huge amount of error checking routines
// If any of these are YES, we are going
// to drop out of updating the records.
//---------------------------------------

$NumberOfRows = $HTTP_POST_VARS["NumberOfRows"];

for ($Loopy = 0; $Loopy < $NumberOfRows; $Loopy++) {
  
  //------------------------------------------
  // Our first check is to see if the entry is 
  // being deleted.  We do not care what is in
  // the field if it is going to be wiped out.
  //------------------------------------------
  
  $Delete[$Loopy]      = $HTTP_POST_VARS["Delete" .      $Loopy];
  $AudioURL[$Loopy]    = $HTTP_POST_VARS["AudioURL" .    $Loopy];
  $TheMenuName[$Loopy] = $HTTP_POST_VARS["TheMenuName" . $Loopy];
  $Position[$Loopy]    = $HTTP_POST_VARS["Position" .    $Loopy];
  $Digit[$Loopy]       = $HTTP_POST_VARS["Digit" .       $Loopy];
  $ActionType[$Loopy]  = $HTTP_POST_VARS["ActionType" .  $Loopy];
  $Destination[$Loopy] = $HTTP_POST_VARS["Destination" . $Loopy];
  $UniqueID[$Loopy]    = $HTTP_POST_VARS["UniqueID" .    $Loopy];
  
  //------------------------------------------------------------------
  // PHP makes single slashes (\) into double slashes (\\) by default.
  // We don't want that.
  //------------------------------------------------------------------
    
  $AudioURL[$Loopy]    = stripslashes($AudioURL[$Loopy]);
  $Destination[$Loopy] = stripslashes($Destination[$Loopy]);
  
  if (!$Delete[$Loopy]) {
    $EntireMenuDeleted = "NO";
  
    if ($AudioURL[$Loopy]    == "") { $AudioURLIsBlank = "YES"; }
    if ($TheMenuName[$Loopy] == "") { $MenuNameIsBlank = "YES"; }
    if ($Position[$Loopy]    == "") { $PositionIsBlank = "YES"; }
    if ($Digit[$Loopy]       == "") { $DigitIsBlank    = "YES"; }
    if ( ( ($ActionType[$Loopy] != "Greeting" ) && 
           ($ActionType[$Loopy] != "Hangup" ) ) && 
	 	   ($Destination[$Loopy] == "" ) ) { $DestinationIsBlank = "YES"; }
		   
	//------------------------------------------------------
	// Make sure the digits are valid "1234567890*#ABCD" and
	// the positions are numeric.
	//------------------------------------------------------
  
    if ($ActionType[$Loopy] != "Greeting") {
      if (! in_array($Digit[$Loopy], $ValidDigits)) { $DigitNotValid    = "YES"; }
	  if (! is_numeric($Position[$Loopy]))          { $PositionNotValid = "YES"; }
	  
	  if ($ActionType[$Loopy] == "Call") {
	    //--------------------------------------------------
	    // Go ahead and remove common items in phone numbers
		// like (, ), and -
		//--------------------------------------------------
	  
	    $Destination[$Loopy] = str_replace("-", "", $Destination[$Loopy]);
	    $Destination[$Loopy] = str_replace("(", "", $Destination[$Loopy]);
	    $Destination[$Loopy] = str_replace(")", "", $Destination[$Loopy]);		
		
	    //-------------------------------------------------------------------
	    // Make sure the digits in a call action are valid "1234567890*#ABCD" 
	    //-------------------------------------------------------------------	
			  
	    for ($Loopy_Z = 0; $Loopy_Z < strlen($Destination[$Loopy]); $Loopy_Z++) {
		  $TempStr = $Destination[$Loopy];
		  if (! in_array($TempStr[$Loopy_Z], $ValidDigits)) { $DestinationNotValid = "YES"; }
	    }  // for statement
	  }  // if statement
    }  // if statement
	
	//--------------------------------------------------------
	// Check to see if there are duplicate digits or positions
	//--------------------------------------------------------
	
	if ($ActionType[$Loopy] != "Greeting") {
	  for ($Loopy1 = 0; $Loopy1 < $Loopy; $Loopy1++) {
	    if (($Digit[$Loopy1]    == $Digit[$Loopy]) &&
	        (! $Delete[$Loopy1] )                  &&
		    ($ActionType[$Loopy1] != "Greeting") ) { $DuplicateDigit    = "YES"; }
		  
	    if (($Position[$Loopy1] == $Position[$Loopy]) &&
	        (! $Delete[$Loopy1] )                     &&
	  	    ($ActionType[$Loopy1] != "Greeting") ) { $DuplicatePosition = "YES"; }
	  }  // for statement
	}  // if statement
  }  // if statement (delete check)
}  // for statement

if ( ($AudioURLIsBlank     == "NO") &&
     ($MenuNameIsBlank     == "NO") &&
	 ($PositionIsBlank     == "NO") &&
	 ($DigitIsBlank        == "NO") &&
	 ($DestinationIsBlank  == "NO") &&
	 ($DigitNotValid       == "NO") && 
	 ($PositionNotValid    == "NO") &&
	 ($DuplicateDigit      == "NO") &&
	 ($DuplicatePosition   == "NO") && 
	 ($DestinationNotValid == "NO") ) {
	 
 //-----------------------------------------------------
  // Here we loop through our entire list of rows, as
  // we *could* be updating like 16 or so rows at a time.
  //-----------------------------------------------------	 
  
  for ($Loopy = 0; $Loopy < $NumberOfRows; $Loopy++) {

    //-------------------------------------------
    // Check to see if the item is to be deleted.
    //-------------------------------------------
    
	if ($Delete[$Loopy]) {
	  $TempSQL = "delete from AUTOATTENDANTDB where UNIQUEID = $UniqueID[$Loopy]";
	}  // if statement
	else {
      
	  //-------------------------------------
      // Build up our big udpate query string
      //-------------------------------------

      $TempSQL = "update AUTOATTENDANTDB set DIGIT = '$Digit[$Loopy]', " . 
    		     "AUDIOURL = '$AudioURL[$Loopy]', " . 
			     "DESTINATION = '$Destination[$Loopy]', " .
			     "MENUNAME = '$TheMenuName[$Loopy]', " . 
			     "ACTIONTYPE = '$ActionType[$Loopy]', " .
			     "MENUPOSITION = $Position[$Loopy] " .
			     "where UNIQUEID = $UniqueID[$Loopy]";
	}  // else statement
			 
    //---------------------
    // Do the update/delete
    //---------------------
	
    $TempDataBase = ReadDatabase( $TempConnection, $TempSQL ); 
	
  }  // for statement	 
 
  //------------------------------------------------------
  // Set the delay length for if the information was saved
  //------------------------------------------------------
  
  $LengthOfDelay = 7; 
  
  //---------------------------------------------------
  // Small check to see if the entire menu was deleted.  
  // If it was,display an appropriate message.
  //---------------------------------------------------
  
  if ($EntireMenuDeleted == "YES") {
    echo "<br><blockquote>All items in menu \"" . $TempMenuName. "\" have been deleted.<br>" .
		 "This menu is now removed from the database.<br><br>"; 
	$TempMenuName = "";   
  }  // if statement   
  else {
    echo "<br><blockquote>Menu \"" . $TempMenuName. "\" has been successfully updated.<br><br>";
  }  // else statement

  echo "This page will automatically return to the Auto Attendant Administrative page in $LengthOfDelay seconds...\n" .
	   "</blockquote>";  
}  // if statement
else {

  echo "<br><blockquote>Menu \"" . $TempMenuName. "\" has <B>NOT</B> been updated.<br><br>" .
       "The following errors in data entry occurred:\n";
  echo "<UL>";
	
  if ($AudioURLIsBlank == "YES") { 
    echo "<LI>One or more Audio URLs were left blank. &nbsp;This is a required field for all items.</LI>\n";
  }  // if statement
 
  if ($MenuNameIsBlank == "YES") {
    echo "<LI>One or more Menu Names were left blank.  &nbsp;This is a required field for all items.</LI>\n";
  }  // if statement
 
  if ($PositionIsBlank == "YES") {
    echo "<LI>One or more Positions were left blank.  &nbsp;This is a required field for all items.</LI>\n";
  }  // if statement
 
  if ($DigitIsBlank == "YES") {
    echo "<LI>One or more Digits were left blank.  &nbsp;This is a required field for all items.</LI>\n";
  }  // if statement
   
  if ($DestinationIsBlank == "YES") {
    echo "<LI>One or more Destinations were left blank.  &nbsp;Only entries of the 'Greeting' and 'Hangup' " .
         "Action Types may be blank -- all others are required.</LI>\n";
  }  // if statement
  
  if ($DigitNotValid == "YES") {
    echo "<LI>One of more Digits were invalid.  &nbsp;There are only 16 valid possibilities: '1234567890 *# ABCD'</LI>\n";
  }  // if statement
  
  if ($PositionNotValid == "YES") {
    echo "<LI>One or more Positions were invalid.  &nbsp;Positions must be numeric</LI>\n";
  }  // if statement
  
  if ($DuplicateDigit == "YES") {
    echo "<LI>You cannot have duplicate digits in your menu.</LI>\n";
  }  // if statement
  
  if ($DuplicatePosition == "YES") {
    echo "<LI>You cannot have duplicate positions in your menu.</LI>\n";
  }  // if statement
  
  if ($DestinationNotValid == "YES") {
    echo "<LI>You must enter a valid phone code for 'Call' items.  Only 1234567890#*ABCD can be used.</LI>\n";
  }  // if statement  
 	   
  echo "</UL></blockquote>";
  
  //-------------------------
  // Set the delay length for 
  // if there was an error
  //-------------------------
  
  $LengthOfDelay = 20;
  
  echo "<br><blockquote>" . 
  	   "This page will automatically return to the Auto Attendant Administrative page in $LengthOfDelay seconds...\n" .
	   "</blockquote>";  
}  // else statement

}  // else statement (If we are not adding an entry)
  

if ($AutomaticReturn != "FALSE") {
  //------------------------------------------------------------
  // Delay for a bit and then redirect back to the 
  // AutoAttendantAdmin.php file, sending the MenuName with it.
  //------------------------------------------------------------
  
  

  RedirectToNewURL( $LengthOfDelay, "$Path" . "autoattendantadmin.php?OS=" . $HTTP_GET_VARS["OS"] . 
  									"&MenuName=" . str_replace(" ", "%20", $TempMenuName) );

  echo "<br><br><hr><br><blockquote>";
  echo "If your browser does not take you back to the Administrative Page, simply" . 
       "<a href=\"$Path" . "autoattendantadmin.php?OS=" . $HTTP_GET_VARS["OS"] . "&MenuName=" . $TempMenuName . "\"> <B>Click Here</B> </a>" .
	   "and you will taken back.</blockquote>";
}  // if statement
else {
  //---------------------------------------------------------------------------
  // For some reason, possibly adding a menu, we are not going to automatically 
  // return to the other menu.  Thus, a different display message is needed.
  //---------------------------------------------------------------------------
  
  echo "<br><br><hr><br><div align=center>";
  echo "To return to the previous page, simply" . 
       "<a href=\"$Path" . "autoattendantadmin.php?OS=" . $HTTP_GET_VARS["OS"] . "&MenuName=" . $TempMenuName . "\"> <B>Click Here</B> </a>" .
	   "and you will taken back.</div>";

}  // else statement

 
//------------------------------
// Close the Database connection
//------------------------------
 
CloseDatabase( $TempConnection );
	 
echo "</body></html>";					  
?>


